'use strict';


var myApp = angular.module('myApp', [
//    'wu.masonry',
    'ngSanitize',
    'ngTouch',
    'ngRoute',
    'ngAnimate',
    'infinite-scroll',
    'myApp.controllers',
    'myApp.filters',
    'myApp.directives',
    'myApp.services'
]).
config(['$routeProvider', function ($routeProvider) {
    //Use promises here http://stackoverflow.com/questions/21945427/how-to-make-ng-view-wait-for-xhr-response
    $routeProvider.when('/about', {templateUrl: 'partials/about.html', controller: 'AboutCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/about/:articleId', {templateUrl: 'partials/about-detail.html', controller: 'AboutDetailCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/courses', {templateUrl: 'partials/courses.html', controller: 'CoursesCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/courses/:courseId', {templateUrl: 'partials/courses-details.html', controller: 'CoursesDetailCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/blog', {templateUrl: 'partials/blog.html', controller: 'BlogCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/blog/:blogId', {templateUrl: 'partials/blog-details.html', controller: 'BlogDetailCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/events', {templateUrl: 'partials/events.html', controller: 'EventsCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.when('/events/:eventId', {templateUrl: 'partials/event-details.html', controller: 'EventsDetailCtrl', resolve: {deferred: function($q) { return $q.defer(); }}});
    $routeProvider.otherwise({redirectTo: 'about'});
}]);

/* angular.module('exceptionOverride', []).factory('$exceptionHandler', function () {
    return function (exception, cause) {
        window.e = exception;
        if(PROD){
            document.body.innerHTML = exception.stack;
            document.body.style.background='#fff';
        }
        else
        throw exception;
    };
  });
 */