'use strict';

angular.module('myApp.filters', [])
	.filter('excerpt', function(  ){
		return function(input, length){
			var text = htmlToPlaintext(input);
			text = text.split('===')[0];
			if(length){
				return text.substr(0, length) + '...';
			}
			else{
				return replaceHref(text);
			}
		}
	})
	.filter('aboutImage', function(){
		return function(input){
			var regex = /<img.*?src="(.*?\/([^\/"]*))".*?>/g,
				src = input.match( regex );
			return src && src[0];
		}
	})
	.filter('blogImage', function(){
		return function(input){
			var regex = /<img.*?src="(.*?\/([^\/"]*))".*?>/g,
			src = input && input.match( regex );
			return src && src[0];
		}
	})
	.filter('floatToTime', function(){
		return function(input){
			input = input.replace('00:', '');
			input = input.replace(/^0/, '');
			return input;
		}
	})
	.filter('img', function(){
		return function(input){
			var imgName = input.replace("'", '').replace(" ", '').toLowerCase();
			return services.image[imgName];
		}
	})
	.filter('withoutImage', function(){
		return function(input){
			var html = input.split('===</p>')[1]
			if(html == null){
				return input;
			}
			else {
				return html;
			}
		}
	})
	.filter('eventColor', function(){
		return function(eventTitle){
			if(eventTitle){
				var index = eventTitle.split(' ').join('').toLocaleLowerCase();
			}
			if(services.eventColorCSSclass[index]){
				return services.eventColorCSSclass[index];
			}
			else{
				return services.eventColorCSSclass['default'];
			}
		}
	})
	.filter('withoutLink', function(){
		return function(input){
			/*
			window.input = input;
			var regex = /<a[^>]+href="?([^"\s]+)"?/g; 
			var newHtml = input;
			var match;
			while((match = regex.exec(input)) !== null){
				var linkHref = match[1]
				newHtml = newHtml.replace(linkHref, 'javascript:open(\'' + linkHref + '\')');
			}; ;*/
			var html = input.replace(/<p><a.*?<\/a><\/p>/, ''),
				html = html.split('===').join(''),
				jHtml = jQuery('<div>' + html + '</div>'),
				lastLink = jHtml.find('p:last a');
			if(lastLink){
				lastLink.parent().remove();
				html = jHtml[0].innerHTML;
			}
			return html;
		}
	})
	.filter('locationAddress', function(){
		return function(input){
			return input.split('\\,').slice(1).join(' ')
		}
	})
	.filter('locationName', function(){
		return function(input){
			return input.split('\\,')[0]
		}
	})
	.filter('replaceHref', function(){
		return function(input){
			return replaceHref(input);
		}
	})