var ENV = (window.location.hostname == 'localhost' ? 'DEV' : 'PROD');
    //ENV = 'PROD';
    var DEV = false, PROD = false;
    var STAGE = true;

    var services = {};

    if(ENV == 'DEV'){
        DEV = true;
        services.about = "js/DEVdata/about.json";
        services.events = "js/DEVdata/events.json";
        services.blog = "js/DEVdata/blog.json";
        services.podcast = "js/DEVdata/podcast.xml";
        services.courses = "js/DEVdata/itunes.json";
    }
    else if(ENV == 'PROD'){
        PROD = true;
        services.about = "https://public-api.wordpress.com/rest/v1/sites/54142117/posts?pretty=1&type=page";
        services.events = "http://houstonsfirst.org/_media/houstons-first-baptist-church-mens-events.ics";
        services.blog = "https://www.googleapis.com/blogger/v3/blogs/16524623/posts?key=AIzaSyDWQZ694qjlwasioQEZQfZSsWKuT_Szce4";
        services.podcast = "http://stepuphouston.com/podcast-ids/";
        services.courses = "https://itunes.apple.com/lookup";
    }
    services.image = {
        warriorsheart: 'http://media.houstonsfirst.org.s3.amazonaws.com/uploaded/m/0e2878763_1391810052_mens-warriors-heart-study-2014-hd.jpg',
        playbtn: 'Images/Course/play@2x.png',
        pausebtn: 'Images/Course/pause@2x.png',
        aboutbtn: 'Images/Course/pause@2x.png',
        calendarblack: 'Images/Events/calendar_icon@2x.png',
        calendargrey: 'Images/Events/event_calendar_icon@2x.png',
        mapicon: 'Images/Events/event_map_icon@2x.png',
        loading: 'Images/General/loader.gif',
        share: 'Images/Events/share_icon@2x.png',
        mainbackground: 'Images/About/about_background@2x.png',
        x: ''
    };
    services.eventColorCSSclass = {
        'men:serve': 'color5',
        'journeyofhope': 'color6',
        'default': 'color4'
    };
    services.googleApiKey = "AIzaSyDqH8BAwAvKcgMmwD2K4MbacBGpJ2kqNRo";

    function get(key){
        return $.jStorage.get(key);
    }
    function set(key, value){
        $.jStorage.set(key, value);
    }
    function htmlToPlaintext(text) {
        return String(text).replace(/<[^>]+>/gm, '');
    }

    function findById (arr, id, idProp) {
        if(!arr){
            return false;
        }
        id= ( isNaN(id) ? id :  parseInt(id));
        var row = null,
        l = arr.length,
        i;
        for (i = 0; i < l; i = i + 1) {
        //The id may be spelled differently
        var ID =  idProp || ( arr[i].id != null ? 'id' : 'ID');
        if (arr[i][ID] === id || (ID =='uid.value' && arr[i].uid.value == id) || parseInt(arr[i][ID]) === id) {
            row = arr[i];
            row.index = i;
            break;
        }
    }
return row;
}
function filterAbout(about){
    var podcastIds = '';
    for(var i = about.length; i > 0; i--){
        var article = about[i];
        if(!article){
            continue;
        }
        switch(parseInt(article.ID)){
            case 45:
              var pIds = article.content.split(/^<p>|<\/p>\n<p>|<\/p>\n$/);
              pIds.shift();
              pIds.pop();
              podcastIds = pIds.join(',');
              set('podcastIds', podcastIds);
              about.splice(i, 1);
            break;
            case 1:
              about.splice(i, 1);
            break;

        }
    }
    return about;
}
function parseXml(xml) {
    var dom = null;
    if (window.DOMParser) {
        try { 
            dom = (new DOMParser()).parseFromString(xml, "text/xml"); 
        } 
        catch (e) { dom = null; }
    }
    else if (window.ActiveXObject) {
        try {
            dom = new ActiveXObject('Microsoft.XMLDOM');
            dom.async = false;
if (!dom.loadXML(xml)) // parse error ..

    window.alert(dom.parseError.reason + dom.parseError.srcText);
} 
catch (e) { dom = null; }
}
else
    alert("cannot parse xml string!");
return dom;
}
function floatToTime( ms ){
    var hr = (ms/3600) << 0,
    min = (ms/60) << 0,
    sec = (ms << 0) % 60;
    return (hr >= 1 && ( hr + ':' )) + min + ':' + sec;

}
function bottomLinkHeight(){
    var bottomLinkRatio = 90 / 160;
    var bottomLinkWidth = (window.innerWidth -3 ) / 4;
    var bottomLinkHeight = bottomLinkWidth * bottomLinkRatio;
    var maxHeight = 75;
    return bottomLinkHeight < maxHeight ? bottomLinkHeight : maxHeight;
}
//To integrate iPhone's colors
function color( c ){ return 255 * parseFloat(c) }
function stringToColor(str){ str.match(/\d\.\d{2}/g).forEach(function(b){console.log(color(b))})}
/*function openLinkInBrowser( ele ){
  console.log(ele);
  return false;
}*/
function replaceHref(input){
    window.input = input;
    var regex = /<a[^>]+href="?([^"\s]+)"?/g; 
    var newHtml = input;
    var match;
    //Open Links using a browser
    while((match = regex.exec(input)) !== null){
        var linkHref = match[1]
        newHtml = newHtml.replace(linkHref, 'javascript:openLink(\'' + linkHref + '\')');
    }
    //Fix telephone numbers
    newHtml = newHtml.replace(/(\d{3}-\d{3}-\d{4})/g, "<a class='phone' href='tel:$1'>$1</a>");
    newHtml = newHtml.replace(/([A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4})/g, "<a href='mailto:$1'>$1</a>");
    return newHtml;
}
function openLink (link){
            if(DEV){
                window.open(link);
            }
            else{
                navigator.app.loadUrl(link, {openExternal : true});
            }
        }
function share( e ){
    //To Do: get the share from Blog/Event
}
function goToCalendar( e, filter ){
    console.log(e);
    console.log(filter);
    //https://github.com/EddyVerbruggen/Calendar-PhoneGap-Plugin
    //To Do: get the calendar info from Event
    var startDate = getCalendarDate(e.dtstart.value, filter); // beware: month 0 = january, 11 = december
    var endDate = getCalendarDate(e.dtend.value, filter); // beware: month 0 = january, 11 = december
    var title = e.summary.value;
    var location = e.location.value && e.location.value.replace(/\\/g, '');
    var notes = e.description.value && e.description.value.replace(/\\/g, '');
    var success = function(message) {  };
    var error = function(message) { alert("Unable to save this event."); };

    //android
    if(window.plugins)
        window.plugins.calendar.createEventInteractively(title,location,notes,startDate,endDate,success,error);
}
function shareEvent( e, $filter){
    var message = [
        "Houston's First Baptist Men's Event\n\r\n\r",
        e.summary.value + "\n\r\n\r\n\r",
        e.description.value.replace(/\\/g, '') + "\n\r\n\r",
        "This event will be the next ",
        $filter('date')(e.dtstart.value, "MMMM d @ h:m a").replace('@', 'at'),
        " in " + e.location.value.replace(/\\/g, '') + ".\n\r",
        "More info:\n\r" + e.url.value
    ].join('');

    var title = "";
    var link = '';
    share(message, title);

}
function share(message, title, link){
    if(window.plugins){
        window.plugins.socialsharing.share(message, title, null, link);
    }
}
function getCalendarDate(dt, filter){
    var year = filter('date')(dt, 'yyyy'),
        month = filter('date')(dt, 'M') - 1,
        day = filter('date')(dt, 'dd'),
        hour = filter('date')(dt, 'HH'),
        minute = filter('date')(dt, 'mm');
    return new Date(year, month, day, hour, minute);
}
function stripCommentsFromXML( XML ){
    var regex = /<!\[CDATA\[|\]\]>\n/g;
    return XML.replace(regex, '');
}
function setIscroll(){
    if(!window.device){
        document.addEventListener("deviceready", setIscroll, false);
    }
    else{
        if(PROD && parseInt(device.version) < 4){
            //window.myScroll = new IScroll('#wrapper', {  scrollY: true });
        }  
    }
}
document.addEventListener("deviceready", onDeviceReady, false);
function onDeviceReady (){
    if(ROD && parseInt(device.version) < 4){
        //document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);
    }
}
function orderEventsByDate(events){
    return events.sort(function(a, b, c){

        if(!a || !a.dtstart){
            return 1;
        }
        if(!b || !b.dtstart){
            return -1;
        }
        return a.dtstart.value < b.dtstart.value ? -1 : 1;
    });
}

function setBlogMasonry(){
    var $container = $('#blog-content .columns');
// initialize Masonry after all images have loaded  
    $container.imagesLoaded( function() {
        $('.isotope').isotope('destroy');
        $container.isotope({
            sortBy: 'original-order',
            itemSelector: '.content',
            masonry: {
                gutter: 5
            },
            sortAscending: true
        }).addClass('isotope');
        window.fetching = false;
    });
    $('#blog-content .columns .content:last').addClass('last-brick')
}
function getLastBlogBricks(){
    var nextBricks = $('.last-brick').nextAll();
    $('.last-brick').removeClass('last-brick');
    return nextBricks;
}
function animationStyles(){
    var windowWidth = $(window).width();
    var styles = [
        ".slide-left.ng-enter {",
            "z-index: 99;",
            "-webkit-transform: translateX({{translateWidth}}px);",
            "transform: translateX({{translateWidth}}px);",
        "}",
        ".slide-left.ng-leave.ng-leave-active {",
            "-webkit-transform: translateX(-{{translateWidth}}px);",
            "transform: translateX(-{{translateWidth}}px);",
        "}",
        ".slide-right.ng-enter {",
            "z-index: 80;",
            "-webkit-transform: translateX(-{{translateWidth}}px);",
            "transform: translateX(-{{translateWidth}}px);",
        "}",
        ".slide-right.ng-leave.ng-leave-active {",
            "-webkit-transform: translateX({{translateWidth}}px);",
            "transform: translateX({{translateWidth}}px);",
        "}"].join('').replace(/{{translateWidth}}/g, windowWidth);
        $("#animationStyles").html('<style>' + styles + '</style>');
        //return '<style>' + styles + '</style>';
}